package cn.iocoder.yudao.module.member.service.card;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.member.controller.admin.card.vo.CardPageReqVO;
import cn.iocoder.yudao.module.member.controller.admin.card.vo.CardSaveReqVO;
import cn.iocoder.yudao.module.member.controller.admin.card.vo.RechargeVO;
import cn.iocoder.yudao.module.member.controller.app.card.vo.AppCardMonthVO;
import cn.iocoder.yudao.module.member.controller.app.card.vo.AppCardPageReqVO;
import cn.iocoder.yudao.module.member.controller.app.card.vo.FaceVo;
import cn.iocoder.yudao.module.member.dal.dataobject.card.CardDO;

import javax.validation.Valid;
import java.math.BigDecimal;
import java.util.List;

/**
 * 余额变动明细 Service 接口
 *
 * @author 开发账号
 */
public interface CardService {

    /**
     * 创建余额变动明细
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createCard(@Valid CardSaveReqVO createReqVO);

    /**
     * 更新余额变动明细
     *
     * @param updateReqVO 更新信息
     */
    void updateCard(@Valid CardSaveReqVO updateReqVO);

    /**
     * 删除余额变动明细
     *
     * @param id 编号
     */
    void deleteCard(Long id);

    /**
     * 获得余额变动明细
     *
     * @param id 编号
     * @return 余额变动明细
     */
    CardDO getCard(Long id);

    /**
     * 获得余额变动明细分页
     *
     * @param pageReqVO 分页查询
     * @return 余额变动明细分页
     */
    PageResult<CardDO> getCardPage(CardPageReqVO pageReqVO);

    /**
     * 获得余额变动明细分页
     *
     * @param pageReqVO 分页查询
     * @return 余额变动明细分页
     */
    PageResult<CardDO> getCardPage(AppCardPageReqVO pageReqVO);

    /**
     * 余额变动
     */
    Boolean recharge(BigDecimal money, String flag,BigDecimal giftMoney);

    /**
     * 获取余额
     */
    BigDecimal getMoney();

    /**
     * 获取余额
     */
    BigDecimal getMoneyByUserId(Long userId);

    CardDO getCardDoByUserId(Long userId);
    /**
     * 批量扣款
     */
    void insertBatch(List<CardDO> list);

    /**
     * 批量扣款
     */
    void insertOne(CardDO cardDO);


    AppCardMonthVO getMonthMoney(Long userId,String flag, String time);

    Boolean rechargeByAdmin(RechargeVO vo);

    FaceVo getFaceData(String faceId);

    void refund(Long userId,BigDecimal money,Long orderId);

    BigDecimal getCashMoney(Long userId);

    Boolean cashDraw(Long userId,BigDecimal money);
}